import "dart:html";

class DaySection
{  
  DaySection(this._color, this._timeStart, this._timeEnd, [this._extra = null]);
  
  DivElement spawn(DateTime date)
  {
    _date = date.toIso8601String();
    _date = _date.substring(0, _date.indexOf("T"));
    DateTime timeStartDate = DateTime.parse(_date + " " + _timeStart);            
    DateTime timeEndDate = DateTime.parse(_date + " " + _timeEnd);
     
    int minutes = timeEndDate.difference(timeStartDate).inMinutes;
    int sectionTop = (0.5 * (timeStartDate.difference(DateTime.parse(_date + " 00:00")).inMinutes - 360)).round();
    int sectionHeight = (0.5 * minutes).round();
     
    _element = new DivElement();
    _element.style.position = "absolute";
    _element.style.top = sectionTop.toString() + "px";
    _element.style.width = "100%";
    _element.style.display = "block";
    _element.style.backgroundColor = _color;
    _element.style.opacity = "0.3";
    _element.style.height = sectionHeight.toString() + "px";
    _element.style.borderTop = _element.style.borderBottom = "1px solid black";
   /* 
    _element.dataset["time_start"] = _timeStart;
    _element.dataset["time_end"] = _timeEnd;
  
   */
    return _element;
  }
    
  String get date => _date;
  DivElement get element => _element;
  List<String> get extra => _extra;
  String get timeEnd => _timeEnd;
  String get timeStart => _timeStart;
  
  String _color;
  String _timeStart;
  String _timeEnd;
  String _date;
  List<String> _extra;
  DivElement _element;
}

class Day
{
  Day(this._date)
  {
    _content = new DivElement();
  }
  
  void clear()
  {
    _content.children.clear();    
  }
  
  void addSection(DaySection section)
  {
    if (section == null) throw new ArgumentError.notNull("section");
    
    _content.children.add(section.spawn(_date));
    _sections.add(section);   
  }
 
  List<DaySection> get sections => _sections;
  
  final DateTime _date;
  DivElement _content;
  DivElement get content => _content;
  List<DaySection> _sections = new List();
}
